codeforces 666C - Codeword

题目链接:http://codeforces.com/problemset/problem/666/C

--------------------------------------------------------------------------------------

玩玩样例大概就能发现答案与字符串内容无关 只与字符串长度$L$以及询问长度$N$有关

对于单组询问 $O(N)$ 的公式也是很显然的 只要预处理一下 阶乘 逆元 等就好

然而按照题意 显然是可以卡到进行$M$次询问 最终复杂度$O(MN)$ 的

比赛时做到这里我就开始思考是不是可以把公式优化下 使得单次询问代价更低

按照这种思路 一直到比赛结束我都没有想出......

优化公式的方法失败了 我们再回头看下公式

用$f[i][j]$代表$L$为$i$ $N$为$j$的答案

则$f[i][j]$ = $f[i][j - 1] * 26 + 25 ^ (j - i) * C(j - 1, i - 1), (i <= j)$

于是我们是可以以$O(n)$的复杂度解决$L$为同一值的询问的

看起来只是对于多次询问相同$L$的情况效率较高$?$

我们不妨试试如何$hack$掉这种方法

既然对于询问相同$L$效率较高 我们干脆不断修改$L$ 比如使$L$为$1\ 2\ 3\ ...$这样的递增数列

这时我们又会发现题目其实还有一个限制条件 字符串总长$($设为$S)$不超过 $10 ^ 5$

$($不知道有没有人比赛时和我一样 把这个条件认为是防止卡读入的 然后直接忽略了$...)$

有了这个限制条件 $L$ 最多就只有差不多 $\sqrt{2S}$个 大概也就是$450$的样子

于是就可以通过上述方法 以$O(\sqrt{S}*N)$的复杂度解决此题了

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 const int N = 1e5 + 10, mod = 1e9 + 7, S2N = 450;
 4 long long a25[N], a[N], inv[N];
 5 int ans[S2N][N];
 6 int ma[N];
 7 char s[N];
 8 int m, n, l, op, cnt;
 9 long long qpow(long long x, int y)
10 {
11     long long re = 1, t = x;
12     while(y)
13     {
14         if(y & 1)
15             re = re * t % mod;
16         t = t * t % mod;
17         y >>= 1;
18     }
19     return re;
20 }
21 void calc(int x)
22 {
23     int y = ma[x];
24     ans[y][x] = 1;
25     for(int i = x + 1; i <= 100000; ++i)
26         ans[y][i] = ((long long)ans[y][i - 1] * 26 + a25[i - x] * a[i - 1] % mod
27         * inv[x - 1] % mod * inv[i - x]) % mod;
28 }
29 int main()
30 {
31     a25[0] = 1;
32     a[0] = 1;
33     inv[0] = 1;
34     for(int i = 1; i <= 100000; ++i)
35     {
36         a25[i] = a25[i - 1] * 25 % mod;
37         a[i] = a[i - 1] * i % mod;
38         inv[i] = qpow(a[i], mod - 2);
39     }
40     scanf("%d", &m);
41     scanf("%s", s);
42     l = strlen(s);
43     ma[l] = ++cnt;
44         calc(l);
45     while(m--)
46     {
47         scanf("%d", &op);
48         if(op & 1)
49         {
50             scanf("%s", s);
51             l = strlen(s);
52             if(!ma[l])
53             {
54                 ma[l] = ++cnt;
55                 calc(l);
56             }
57         }
58         else
59         {
60             scanf("%d", &n);
61             if(n < l)
62             {
63                 puts("0");
64                 continue;
65             }
66             else
67                 printf("%d\n", ans[ma[l]][n]);
68         }
69     }
70     return 0;
71 }
时间: 2024-11-09 05:42:11

codeforces 666C - Codeword的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ